import { PublicKey } from '@solana/web3.js';
import { Program } from '@coral-xyz/anchor';
import { utils } from '@wormhole-foundation/sdk-solana';
import { WormholeCoder } from './coder/index.js';
// ts-ignoring because of this nonsense https://github.com/microsoft/TypeScript/issues/51783
/* @ts-ignore */
import IDL from '../anchor-idl/wormhole.json' assert { type: 'json' };
export function createWormholeProgramInterface(programId, provider) {
    return new Program(IDL, new PublicKey(programId), provider === undefined ? { connection: null } : provider, coder());
}
export function createReadOnlyWormholeProgramInterface(programId, connection) {
    return createWormholeProgramInterface(programId, utils.createReadOnlyProvider(connection));
}
export function coder() {
    return new WormholeCoder(IDL);
}
//# sourceMappingURL=program.js.map